<?php
/**
* @author      Opensource Design, http://www.opensourcedesign.nl
* @copyright   Copyright (C) 2009 Opensource Design. All rights reserved.
* @license     GNU General Public License, http://www.gnu.org/copyleft/gpl.html
* @Version     1.0
*
* The plugin f2c_submitmail is a Form2Content adaption of the jp_submitmailer
* developed by Tobias Kuhn @ JoomlaPraise, http://www.joomlapraise.com
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onAfterInitialise', 'f2c_submitmailer' );

function f2c_submitmailer()
{
	global $mainframe;

	// ensure that the plugin gets triggered only once
	if(!defined('F2C_SUBMITMAILER')) 
	{
		define('F2C_SUBMITMAILER', 1);
	}
	else 
	{
		return false;
	}
	
    $option = JRequest::getCmd('option');
    $task   = JRequest::getCmd('task');
    $id     = (int) JRequest::getVar('id');
    $db     = &JFactory::getDBO();
    $my     = &JFactory::getUser();
    $mail   = &JFactory::getMailer();
    $sub    = 'New Item - '.JURI::base();
    $v_task = array('save', 'apply');
    $p_task = JRequest::getCmd('p_task');
    $pass   = urldecode(JRequest::getVar('pass', '', 'get'));
    $emails = array();
	$sectionId = (int)JRequest::getVar('sectionid', -1);
	$catId = (int)JRequest::getVar('catid', -1);		

    // get the plugin parameters
	$db->setQuery("SELECT params FROM #__plugins WHERE element = 'f2c_submitmailer'");
	$data = $db->loadResult();

	$params = new JParameter($data);
	
	if(	$option != 'com_form2content' || !in_array($task, $v_task) || stristr(JURI::base(), 'administrator')) 
	{
    	return false;
    }

	// return if the user has updated a content item and if we don't want to know about it
	if((int) $params->get('notify_on_update') == 0) 
	{
		return false;
	}
	
	// get the form2content Ids
	$f2cId = (int)JRequest::getVar('id');
	$f2cProjectId = (int)JRequest::getVar('projectid');	

	$db->setQuery("SELECT * FROM #__f2c_project WHERE id = ". (int)$f2cProjectId);
	$project = $db->loadObject();
	
	$contentType = $project->title;

	if($sectionId == -1)	
	{
		if($f2cId)
		{
			$db->setQuery("SELECT sectionid, catid FROM #__f2c_form WHERE id = ". (int)$f2cId);
			$form = $db->loadObject();
			$sectionId = (int)$form->sectionid;
			$catId = (int)$form->catid;					
		}
		else
		{
			$sectionId = (int)$project->sectionid;
			$catId = (int)$project->catid;
		}		
	}
			
	// gets section name of item
	$query = "SELECT s.title"
	       . "\n FROM #__sections AS s"
	       . "\n WHERE s.scope = 'content'"
	       . "\n AND s.id = " . (int)$sectionId;
	       
    $db->setQuery($query);
    $section = stripslashes($db->loadResult());
	if(!$section) $section = JText::_('Uncategorized');

    // gets category name of item
	$query = "SELECT c.title"
	       . "\n FROM #__categories AS c"
	       . "\n WHERE c.id = " . (int)$catId;
	       
   $db->setQuery($query);
   $category = stripslashes($db->loadResult());
	if(!$category) $category = JText::_('Uncategorized');


	if($f2cId) 
	{  
		// User is updating an existing item
		$sub  = $params->get('update_subject');
		$body = $params->get('update_body');
	}
	else 
	{     		
		// User has created a new item
		$sub  = $params->get('new_subject');
		$body = $params->get('new_body');
	}
	
	// prepare email subject
	$sub = str_replace('{url}', JURI::base(), $sub);
	
	$username = ($my->get('username')) ? $my->get('username') : 'Anonymous';
	
	// prepare email body
	$body = str_replace('{username}', $username, $body);
	$body = str_replace('{section}', $section, $body);
	$body = str_replace('{category}', $category, $body);
	$body = str_replace('{contentType}', $contentType, $body);
	$body = str_replace('{title}', JRequest::getVar('title'), $body);
	$body = str_replace('{id}', $f2cId, $body);

	// send email to all admins
    if((int)$params->get('mailto_admins') == 1) 
    {
         $query = "SELECT email FROM #__users WHERE usertype = 'Super Administrator'";
                $db->setQuery($query);
                $tmp_emails = $db->loadResultArray();

         if(!is_array($emails)) { $emails = array(); }
         $emails = array_merge($tmp_emails, $emails);
    }

    // send email to custom addresses
    if((int)$params->get('mailto_custom') == 1 && $params->get('custom_email') != "")  {
        $tmp_emails = explode(';', $params->get('custom_email'));

        if(!is_array($emails)) { $emails = array(); }
        $emails = array_merge($tmp_emails, $emails);
    }
    
    $sent = array();
    
	// send email
    foreach ($emails AS $email)
    {
    	// don't send doubles
    	if(!in_array($email, $sent)) {
    		$email = trim($email);

    		$mail = &JFactory::getMailer();

	        $mail->addRecipient( $email );
	        $mail->setSender( array( $mainframe->getCfg('mailfrom'), $mainframe->getCfg('fromname') ) );
	        $mail->setSubject( $sub );
	        $mail->setBody( $body );

	        $mail->Send();
	        $sent[] = $email;
    	}
    }
}
?>